Subject: Re: [jose] JWT + JOSE for Java

From: "Vladimir Dzhuvinov / NimbusDS" <[email-masked]>
Date: Thu, 05 Apr 2012 04:33:56 -0700

Hey, huge thanks for that!

I remember this weakness mentioned some time ago, but didn't know more
until now.

I'm not planning more work on the JWT library for the next couple of
weeks. So there's no rush, at least for me. If you have a concrete
suggestion how to fix the I would be grateful :)

Cheers,

Vladimir

--
Vladimir Dzhuvinov : www.NimbusDS.com : [email-masked]

-------- Original Message --------
Subject: Re: [jose] JWT + JOSE for Java
From: "Juraj Somorovsky" <[email-masked]>
Date: Thu, April 05, 2012 12:13 am
To: [email-masked]
Cc: [email-masked]

Hi Vladimir,

I have took a look at your implementation and found out, that your PKCS1
handling is vulnerable to the Bleichenbacher attack (the adversary could
be able to issue different ciphertexts, send them to the server, and
according to its responses he could learn the encrypted CEK)

I will send you PoCs and instructions how to fix it by tomorrow...or
just take a look at the document written by Eric Rescorla:
http://www.ietf.org/rfc/rfc3218.txt

Regards
Juraj

On 04/03/2012 11:24 AM, Vladimir Dzhuvinov / NimbusDS wrote:
> Today I reached a point in my JWT+JOSE library implementation where I
> wouldn't feel ashamed to release it to the public :)
> 
> https://github.com/NimbusDS/Nimbus-JWT
> 
> The library is fully documented:
> http://nimbusds.com/files/jwt/javadoc/index.html
> 
> 
> The Nimbus-JWT library started a month ago from code borrowed from Axel
> Nennker's + Co OpenInfoCard project and at this point covers fully plain
> and signed JWTs as well as JSON Web Keys (JWK). The JWE implementation
> still requires a bit of work to add HMAC integrity and cover the
> remaining elliptic curve and key-wrap encryption algorithms from the JWA
> spec. I would be very thankful if somebody could help me with that as I
> don't have much experience with cryptography :)
> 
> For the listing of the supported JWAs:
> http://nimbusds.com/files/jwt/javadoc/com/nimbusds/jwt/JWA.html
> 
> Cheers,
> 
> Vladimir
> --
> Vladimir Dzhuvinov : www.NimbusDS.com : [email-masked]
> 
> _______________________________________________
> jose mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/jose

-- 
M.Sc. Juraj Somorovsky

Lehrstuhl für Netz- und Datensicherheit
Ruhr Universität Bochum
-----------------------------------
Universitätsstr. 150, Geb. ID 2/411
D-44780 Bochum

Telefon: +49 (0) 234 / 32-26551
Fax: +49 (0) 234 / 32-14347
http://www.nds.rub.de